//===================================================================
//        63
module mycounter (
     data,          // parallel optional data
     clock,         // clock 
     cnt_en,        // counter enable
     sload,         // synchronous load
     zero           //   0
);
parameter width=1;
//// port declarations ////
input  [width-1:0] data;
input  clock, cnt_en;
input  sload;
output zero;

reg [width-1:0] count;
assign  zero = (count == 0) ? 1'b1 : 1'b0 ;

// ****************** counter *************************** //
always @( posedge clock)
begin
 if (sload)
   count <= data;
 else if (cnt_en)
    count <= (count == 0) ? 0 : count - 1;
end
endmodule

